function [SE] = Samp_Ent_Govindan2007(data,m,R)
% SampEn with lag as described in "Revisiting sample entropy analysis" by
% R.B. Govindan, J.D. Wilson, H. Eswaran, C.L. Lowery, H. PreiBl (2007).
%
% April 2018 - Created by Will Denton, email: 21denton@gmail.com

r = R * std(data);
N = length(data);

i=1;
acf = 1/exp(1);
while acf(end) >= 1/exp(1)
    [acf,lags,~] = autocorr(data,i); %autocorr(data,'NumLags',i); 
    i=i+1;
end
delta = lags(end);

dij=zeros(N-m*delta,m+1);
dj=zeros(N-m*delta,1);
dj1=zeros(N-m*delta,1);
Bm=zeros(N-m*delta,1);
Am=zeros(N-m*delta,1);

%fprintf(' 00.00%%');
for i = 1:N-m*delta
    for k = 1:delta:m*delta+1
        dij(:,ceil(k/delta)) = abs(data(k:N-m*delta+k-1)-data(i+k-1));
    end
    dj = max(dij(:,1:m),[],2);
    dj1 = max(dij,[],2);
    d = find(dj<=r);
    d1 = find(dj1<=r);
    nm = length(d)-1; % subtract the self match
    Bm(i) = nm/(N-m);
    nm1 = length(d1)-1; % subtract the self match
    Am(i) = nm1/(N-m);
    %if mod(i,1000) == 0
        %fprintf(repmat('\b',1,7));
        %fprintf('%3.0d',floor(i/(N-m)*100));
        %fprintf('.%1.0f',floor(mod((i/(N-m))*100,1)*10));
        %fprintf('%1.0f',floor(mod((i/(N-m))*1000,1)*10));
        %fprintf('%%');
    %end
end
%fprintf(repmat('\b',1,7));
%fprintf('100.00%%');
%fprintf('\r');

Bmr = sum(Bm)/(N-m);
Amr = sum(Am)/(N-m);

SE = -log(Amr/Bmr)*(1/delta);