%for s = 1:4, for c=1:4, Input.(['S' num2str(s) '_C' num2str(c)]) = rand(1000,1); end; end; save('Input.mat','Input');
%% EDIT THESE PARAMETERS FOR SAMPEN CALCULATION
help autocorr;
m = 2:3;
r = 0.1:0.05:0.3;
%% DO NOT EDIT PAST THIS LINE!
%LOAD DATA
load('Input.mat'); files = fieldnames(Input);
%NECESSARY FOR HOLLAND COMPUTING CENTER
num_cores_node=str2num(getenv('SLURM_NTASKS_PER_NODE'));
num_nodes=str2num(getenv('SLURM_JOB_NUM_NODES'));
num_cores = num_cores_node*num_nodes;
parpool(num_cores_node);
%NECESSARY FOR PERSONAL COMPUTER
% num_cores = 4;
%BEGIN PARALLEL PROCESSING
N = length(fieldnames(Input));
fid = fopen('time_per_file.log','w'); fclose(fid);
parfor (i = 1:length(files),num_cores)
    tic;
    temp = struct()
    for M = 1:length(m)
        for R = 1:length(r)
            temp.([files{i} '_m' num2str(M) '_r' num2str(r(R)*100) ]) = Samp_Ent_Govindan2007(Input.(files{i}),m(M),r(R));
        end
    end
    out{i,1} = temp;
    %TIMING
    while 1
        try
            fid = fopen('time_per_file.log','a');
            fwrite(fid,sprintf('%2.4f\r',toc));
            fclose(fid);
            break;
        end
    end
    while 1
        try
            time_per_file = dlmread('time_per_file.log','\r');
            remaining_time = mean(time_per_file)*(N-(length(time_per_file))+1)/num_cores;
            est_completion_time = datestr(now+remaining_time/24/60/60);
            fid = fopen('time_remaining.log','w');
            fwrite(fid,sprintf('Time remaining: %2.4f seconds.\r\nEstimated completion time: %s',remaining_time,est_completion_time));
            fclose(fid);
            break;
        end
    end
end
%REORGANIZE INTO STRUCTURE
for i = 1:length(files)
    field = fieldnames(out{i,1});
    for j = 1:length(field)
        Output.(field{j,1}) = out{i,1}.(field{j,1});
    end
end
Output = OutputStruct(Output);
%SAVE OUTPUT FILE
save('Output.mat','Output');