function [SE] = Samp_Ent(data,m,R)
% Faster version of SampEn
% J McCamley May, 2016

r = R * std(data);
N = length(data);

dij=zeros(N-m,m+1);
dj=zeros(N-m,1);
dj1=zeros(N-m,1);
Bm=zeros(N-m,1);
Am=zeros(N-m,1);

fprintf(' 00.00%%');
for i = 1:N-m
    for k = 1:m+1
        dij(:,k) = abs(data(k:N-m+k-1)-data(i+k-1));
    end
    dj = max(dij(:,1:m),[],2);
    dj1 = max(dij,[],2);
    d = find(dj<=r);
    d1 = find(dj1<=r);
    nm = length(d)-1; % subtract the self match
    Bm(i) = nm/(N-m);
    nm1 = length(d1)-1; % subtract the self match
    Am(i) = nm1/(N-m);
    if mod(i,1000) == 0
        fprintf(repmat('\b',1,7));
        fprintf('%3.0d',floor(i/(N-m)*100));
        fprintf('.%1.0f',floor(mod((i/(N-m))*100,1)*10));
        fprintf('%1.0f',floor(mod((i/(N-m))*1000,1)*10));
        fprintf('%%');
    end
end
fprintf(repmat('\b',1,7));
fprintf('100.00%%');
fprintf('\r');

Bmr = sum(Bm)/(N-m);
Amr = sum(Am)/(N-m);

SE = -log(Amr/Bmr);